// test out simple blinking
// test out PWM
// test out analog outputs
// test out inputs (digital, analog)
// test out I2C (for Adafruit VL53L1X)

#include <VL53L1X.h>
#include <Wire.h>

#define LED 13 
#define digOut 9
#define digIn 8
#define anOut 10
#define anIn 26

const int wait = 2000;
uint16_t distance1 = 0;

VL53L1X sensor1;

void setup() {
  pinMode(LED, OUTPUT); // LED pin
  pinMode(digOut, OUTPUT); // digital output
  pinMode(anOut, OUTPUT); // analog output
  pinMode(digIn, INPUT); // digital input
  pinMode(anIn, INPUT); // analog input

  while(!Serial){}
  Serial.begin(115200);
  Wire.begin();
  Wire.setClock(400000); // use 400kHz I2C

  sensor1.setTimeout(500);
  if(!sensor1.init())
  {
    Serial.println("ERROR");
    while(1);
  }

  sensor1.setDistanceMode(VL53L1X::Long);
  sensor1.setMeasurementTimingBudget(50000);
  sensor1.startContinuous(50);
}

void loop() {
  // put your main code here, to run repeatedly:
  digitalWrite(LED, HIGH);
  digitalWrite(digOut, HIGH);
  analogWrite(anOut, 200);
  Serial.println(analogRead(anIn));
  Serial.print("   ");
  Serial.print(digitalRead(digIn));
  distance1 = sensor1.read();
  Serial.print("   ");
  Serial.print(distance1);
  if (sensor1.timeoutOccurred()) { Serial.print(" TIMEOUT"); }
  delay(wait);
  
  digitalWrite(LED, LOW);
  digitalWrite(digOut, LOW);
  analogWrite(anOut, 100);
  Serial.println(analogRead(anIn));
  Serial.print("   ");
  Serial.print(digitalRead(digIn));
  distance1 = sensor1.read();
  Serial.print("   ");
  Serial.print(distance1);
  if (sensor1.timeoutOccurred()) { Serial.print(" TIMEOUT"); }
  delay(wait);
}
