#include <Wire.h>

#define OPENMV_ADDRESS 0x12

#define CAM3 24

void setup() {
  Wire.begin(); // Join I2C bus as master
  Serial.begin(9600);

  attachInterrupt(digitalPinToInterrupt(CAM3), quickPrint, RISING);
}

void loop() {
  Wire.requestFrom(OPENMV_ADDRESS, 1); // Request  from the OpenMV
  Serial.println("requesting...");
  while (Wire.available())
  {
    char c = Wire.read(); // Read each byte
    Serial.print("Char: ");
    Serial.print(c);
    Serial.print(" Binary: ");
    printBinary(c);
    Serial.println();
  }
  delay(1000); // Wait for a second before reading again
}

void printBinary(char c) {
  for (int i = 7; i >= 0; i--) {
    Serial.print((c >> i) & 1);
  }
}

void quickPrint()
{
  Serial.println("CAM3");
}
