// X is yaw
// Z is roll
// Y is pitch

#include <Wire.h>
#include <Adafruit_Sensor.h>
#include <Adafruit_BNO055.h>

Adafruit_BNO055 bno = Adafruit_BNO055(55);

float initialX, initialY, initialZ;

void setup() {
  Serial.begin(115200);
  if (!bno.begin()) {
    Serial.print("No BNO055 detected ... Check your wiring or I2C ADDR!");
    while (1);
  }

  delay(1000);
  bno.setExtCrystalUse(true);

  // Store the initial orientation values
  sensors_event_t event;
  bno.getEvent(&event);
  initialX = event.orientation.x;
  initialY = event.orientation.y;
  initialZ = event.orientation.z;
}

void loop() {
  sensors_event_t event;
  bno.getEvent(&event);

  // Calculate the angles relative to the initial orientation
  float relativeX = event.orientation.x - initialX;
  float relativeY = event.orientation.y - initialY;
  float relativeZ = event.orientation.z - initialZ;

  Serial.print("X: ");
  Serial.print(relativeX);
  Serial.print(" Y: ");
  Serial.print(relativeY);
  Serial.print(" Z: ");
  Serial.println(relativeZ);

  delay(100);
}
