// HOW TO SET UP:
// put SBTY on LOW for everything to stop, HIGH enbales the motors to recieve voltage
// AIN_M (Side A) has to be LOW to go forward
// BIN_M (Side B) has to be HIGH to go forward
// PWMA (Side A) goes from 0 to 255 (0 to 100%) for speed, mandatory setting for it to work
// PWMB (Side B) goes from 0 to 255 (0 to 100%) for speed, mandatory setting for it to work
// each side can be cinfigured individually for direction and speed
// only ENCB works, (for now no problem)


// DERIVE TO FUNCTION:
// copy #defines, pinModes, and the digitalWrite(STBY, LOW); in setup()
// copy attachInterrupt for ENCB, maybe ENCA
// make separate functions for stopping and going

// void stop_m(int time) just has digitalWrite(STBY, LOW)
// time being a millis delay

// void movement(bool Adir, bool Bdir, Aspeed, Bspeed)
// Adir and Bdir have same logic: 1 = forward, 0 = back, for AIN_M, BIN_M
// Aspeed and Bspeed are just from 0 to 255 for PWMA, PWMB

// define pins
#define STBY 20 // LOW = everything stops
#define AIN_M 22 // HIGH = clockwise for side A; LOW = counterclockwise for side A
#define BIN_M 21 // same here but for side B
#define PWMA 37 // just put the slew rate at whatever
#define PWMB 36 // same here but for side B
#define ENCA 17 // pulses at encoder turning
#define ENCB 16 // same here but for side B

int encoderA = 0;
int encoderB = 0;

bool icain, icbin;

void setup(void)
{
  // define pin modes
  pinMode(STBY, OUTPUT);
  pinMode(AIN_M, OUTPUT);
  pinMode(BIN_M, OUTPUT);
  pinMode(PWMA, OUTPUT);
  pinMode(PWMB, OUTPUT);
  pinMode(ENCA, INPUT);
  pinMode(ENCB, INPUT);

  Serial.begin(9600);
  while((!Serial) && (millis() <= 2000)){}
  digitalWrite(STBY, LOW);
  Serial.println("Driver stopped...");

  //attachInterrupt(digitalPinToInterrupt(ENCA), encodeA, RISING);
  attachInterrupt(digitalPinToInterrupt(ENCB), encodeB, RISING);
}

void loop(void)
{
  digitalWrite(STBY, LOW);
  delay(1000);

  digitalWrite(AIN_M, HIGH); // go back
  icain = true;
  digitalWrite(BIN_M, LOW);
  icbin = false;
  analogWrite(PWMA, 255);
  analogWrite(PWMB, 255);
  digitalWrite(STBY, HIGH);
  delay(1000);

  digitalWrite(STBY, LOW);
  delay(1000);

  digitalWrite(AIN_M, LOW); // go forward
  icain = false;
  digitalWrite(BIN_M, HIGH);
  icbin = true;
  analogWrite(PWMA, 255);
  analogWrite(PWMB, 255);
  digitalWrite(STBY, HIGH);
  delay(1000);
}

void encodeA(void)
{
  if(!icain){
    encoderA++;
  }
  else
  {
    encoderA--;
  
  }
  Serial.println("A = ");
  Serial.print(encoderA);
}

void encodeB(void)
{
  if(icbin){
    encoderB++;
  }
  else
  {
    encoderB--;
  }
  Serial.println("B = ");
  Serial.print(encoderB);
}